var
  l: array[1..100] of char;
  ch_index: array[char] of integer;
  values: array[1..20] of integer;
  digit_used: array[0..9] of boolean;
  a, b, c: string;
  lnum: integer;
  i: integer;

  procedure myassert(b: boolean);
  begin
    if (not b) then
      halt(1);
  end;

  procedure AddLetters(s: string);
  var
    i, j: integer;
    used: boolean;
  begin
    for i := 1 to length(s) do
    begin
      if (not ((s[i] >= '0') and (s[i] <= '9'))) then
      begin
        used := false;
        for j := 1 to lnum do
        begin
          if (s[i] = l[j]) then
          begin
            used := true;
            break;
          end;
        end;
        if (not used) then
        begin
          inc(lnum);
          l[lnum] := s[i];
          ch_index[s[i]] := lnum;
        end;
      end;
    end;
  end;

  function GetNumber(s: string; var z: boolean): integer;
  var
    i: integer;
    digit: integer;
  begin
    Result := 0;
    z := false;
    for i := 1 to length(s) do
    begin
      if ((s[i] >= '0') and (s[i] <= '9')) then
        digit := ord(s[i]) - ord('0')
      else
        digit := values[ch_index[s[i]]];
      if ((i = 1) and (digit = 0)) then
        z := true;
      Result := Result*10 + digit;
    end;
  end;

  procedure rec(num: integer);
  var
    na, nb, nc: integer;
    za, zb, zc: boolean;
    i: integer;
  begin
    if (num > lnum) then
    begin
      na := GetNumber(a, za);
      nb := GetNumber(b, zb);
      nc := GetNumber(c, zc);
      if (not za and not zb and not zc and (na + nb = nc)) then
      begin
        writeln(na);
        writeln(nb);
        writeln(nc);
        writeln;
      end;
    end
    else
    begin
      for i := 0 to 9 do
      begin
        if (not digit_used[i]) then
        begin
          values[num] := i;
          digit_used[i] := true;
          rec(num+1);
          digit_used[i] := false;
        end;
      end;
    end;
  end;

begin
  assign(input, 'input.txt');
  reset(input);
  assign(output, 'output.txt');
  rewrite(output);

  myassert(not SeekEof(input));
  readln(a);
  myassert(not SeekEof(input));
  readln(b);
  myassert(not SeekEof(input));
  readln(c);
  myassert(SeekEof(input));

  myassert((length(a) >= 1) and (length(a) <= 9));
  myassert((length(b) >= 1) and (length(b) <= 9));
  myassert((length(c) >= 1) and (length(c) <= 9));

  lnum := 0;
  AddLetters(a);
  AddLetters(b);
  AddLetters(c);
  myassert((1 <= lnum) and (lnum <= 6));

  for i := 0 to 9 do
    digit_used[i] := false;
  rec(1);

  close(input);
  close(output);
end.

